if (Deno.args.length !== 1) {
    console.log("Usage: ./genmap.js <path-to-map-file>");
    Deno.exit(1);
}

const mapFile = Deno.args[0];
const data = await Deno.readTextFile(mapFile);
const map = JSON.parse(data);

let layer = map.layers[0];

console.log(`pub const map = [${layer.data.length}]Tile{`);

layer.data.forEach((tile, index) => {
    tile -= 1;
    const tileY = Math.trunc(tile / layer.height);
    const tileX = tile % layer.width;
    console.log(`    Tile{.x = ${tileX}, .y = ${tileY}},`);
});

console.log("};");
